/*************************************************************
 *                 bbomberman                                *
 *  (c) 2004 by Bernhard Eder (bb-generation)                *
 *  http://bbgen.net/bomberman for updates                   *
 *  Webmaster@bbgen.net for bug reports and other stuff      *
 * --------------------------------------------------------- *
 * This program is free software; you can modify it under    *
 * the terms of the GNU General Public License as published  *
 * by the Free Software Foundation, located in LICENSE       *
 *                                                           *
 *************************************************************/

#include "main.h"


int main(int argc, char *argv[])
{
  /* install verbose termination handler which deparses thrown exceptions */
  std::set_terminate(__gnu_cxx::__verbose_terminate_handler);

#ifdef STDERRTXT
  /* redirect stderr to "stderr.txt" */
  std::ofstream    out("stderr.txt");
  std::streambuf*  sbuf = std::cerr.rdbuf();
  std::cerr.rdbuf(out.rdbuf());
#endif

  /* create game object & play the game ;) */
  cl_game game;
  game.play();

#ifdef STDERRTXT
  /* reset default stderr */
  std::cerr.rdbuf(sbuf);
#endif

  return 0;
}
