/*************************************************************
 *                 bbomberman                                *
 *  (c) 2004 by Bernhard Eder (bb-generation)                *
 *  http://bbgen.net/bomberman for updates                   *
 *  Webmaster@bbgen.net for bug reports and other stuff      *
 * --------------------------------------------------------- *
 * This program is free software; you can modify it under    *
 * the terms of the GNU General Public License as published  *
 * by the Free Software Foundation, located in LICENSE       *
 *                                                           *
 *************************************************************/

/*
 * cl_server test
 *
 * This test was written when there was no ref_ptr implemented yet...
 * So cl_bomberman (and other) objects were expected to be permanently copied.
 *
 * (This was really the case, but getting a reference to a cl_bomberman
 *  which already was part of a std::vector and modifying it really modified
 *  the object in the vector. So during first rewrite / abstraction improvement
 *  steps, the copying approach was sufficient.)
 *
 * This test is mainly useless now; for details, see the above explanation in
 * parenthesis.
 */

#include "cl_server.h"
#include <iostream>


int main()
{
  std::vector<std::string> names(1, std::string("Player"));

  cl_server_local server(4, 4, names);
  std::cerr << "x: " << server.bombermans[0]->x << "; y: " << server.bombermans[0]->y << std::endl;

  server.bombermans[0]->x = 3;

  std::cerr << "x: " << server.bombermans[0]->x << "; y: " << server.bombermans[0]->y << std::endl;

  return 0;
}
