#include "ref_ptr.h"

#include <vector>
#include <iostream>


class myclass
{
	public:
		int  mydata;

		myclass(const int data) :
			mydata(data)
		{
			std::cerr << "* myclass::myclass()" << std::endl;
		}

		~myclass()
		{
			std::cerr << "* myclass::~myclass()" << std::endl;
		}
};


int main()
{
	typedef  ref_ptr<myclass>     myptr;
	typedef  std::vector<myptr>  instances_type;

	std::cerr << "+ main()" << std::endl;
	instances_type  instances;

	std::cerr << "# main(): creating myclass instances" << std::endl;
	instances.push_back(myptr(new myclass(1)));
	instances.push_back(myptr(new myclass(7)));

	std::cerr << "# main(): iterating through instances using refptr ptr member" << std::endl;
	for (instances_type::iterator i = instances.begin();
	     i < instances.end(); i++)
	{
		std::cerr << "mydata: " << i->get()->mydata << std::endl;
	}

	std::cerr << "# main(): iterating through instances using refptr operator overloading" << std::endl;
	for (instances_type::iterator i = instances.begin();
	     i < instances.end(); i++)
	{
		std::cerr << "mydata: " << (*i)->mydata << std::endl;
	}

	std::cerr << "- main()" << std::endl;

	return 0;
}
